#!perl 
################################################
# Stefano Klett <stefano.klett@gmail.com>
# Maggiori informazioni: http://www.astromania.net
################################################

# Parametro -t 
$divider=96;
# alrti parametri raw2lum
$params="-sm50:5 -s64:64";
# tipo file raw 
$rawtype="dng";
# rotazione di 90, workaround per problema immagini pi grandi di 3998 pixel
$dcrawparams="-t 90";
# cartella programmi e scripts
$bin = "E:\\bin\\";

open(ALLHD,"Dark\\all-head.csv");
$i=0;
while (<ALLHD>) {
	chop;
	@dark=split(/,/,$_);
	if ($i eq 0) {
		$k=0;
		foreach (@dark) {
			$dark_head[$k]=$_;
			$k++;
		}
	} else {
		$k=0;
		foreach (@dark) {
			$dark_photo{$dark_head[$k]}=$_;
			$k++;
		}
		$dark_photo{"File name"}=~/^\s+(\S+).JPG$/;
		if (! -e "Dark\\".$1.".PGM") {
			print($bin."dcraw.exe -v -D -4 ".$dcrawparams." Dark\\$1.".$rawtype);
			print("\n");
			system($bin."dcraw.exe -v -D -4 ".$dcrawparams." Dark\\$1.".$rawtype);
		}
		$dark_summary{$dark_photo{"Exposure time"},$dark_photo{"Aperture"},$dark_photo{"ISO equiv"}}=$dark_photo{"File name"}
	}
	$i++;
}
close (ALLHD);

open(ALLH,"all-head.csv");
$i=0;
while (<ALLH>) {
	chop;
	@shot=split(/,/,$_);
	if ($i eq 0) {
		$k=0;
		foreach (@shot) {
			$shot_head[$k]=$_;
			$k++;
		}
	} else {
		$k=0;
		foreach (@shot) {
			$shot_photo{$dark_head[$k]}=$_;
			$k++;
		}
		$shot_photo{"File name"}=~/^\s+(\S+).JPG$/;
		$foto_frame=$1;
		if (! -e $1.".PGM") {
			print($bin."dcraw.exe -v -D -4 ".$dcrawparams." $1.".$rawtype);
			print("\n");
			system($bin."dcraw.exe -v -D -4 ".$dcrawparams." $1.".$rawtype);
		}
		$dark_frame=$dark_summary{$shot_photo{"Exposure time"},$shot_photo{"Aperture"},$shot_photo{"ISO equiv"}};
		if ($dark_frame=~/^\s+(\S+).JPG$/) {
			$dark_frame=$1;
		} else {
			$dark_frame="";
		}
		if ($dark_frame eq "") {
			if ((!-e $foto_frame.".ppm") or (!-e $foto_frame.".eps")) {
				print("Attenzione trasformazione senza DARKFRAME!!!!\n");
				print($bin."raw2lum.exe -t $divider $params -i $foto_frame-h.txt -fa -n $foto_frame.ppm -e $foto_frame.eps $foto_frame.pgm >$foto_frame.log");
				print("\n");
				system($bin."raw2lum.exe -t $divider $params -i $foto_frame-h.txt -fa -n $foto_frame.ppm -e $foto_frame.eps $foto_frame.pgm >$foto_frame.log");
				print("------------------------\n")
			}
		} else {
			if ((!-e $foto_frame.".ppm") or (!-e $foto_frame.".eps")) {
				$dark_frame="Dark\\".$dark_frame;
				print($bin."raw2lum.exe -t $divider $params -i $foto_frame-h.txt -fa -d $dark_frame.pgm -n $foto_frame.ppm -e $foto_frame.eps $foto_frame.pgm >$foto_frame.log");
				print("\n");
				system($bin."raw2lum.exe -t $divider $params -i $foto_frame-h.txt -fa -d $dark_frame.pgm -n $foto_frame.ppm -e $foto_frame.eps $foto_frame.pgm >$foto_frame.log");
				print("------------------------\n")
			}
		}
	}
	$i++;
}
close (ALLH);

exit;
$max_dark=$i-1;
close (ALLH);
open(ALLH,"all-head.csv");
$i=0;
while (<ALLHD>) {
	chop;
	@photo[$i]=split(/,/,$_);
	$i++;
}
$max_photo=$i-1;
close (ALLH);
for($k = 0; $k < $max_poto; $k++) {
	
}


while (<ALLH>) {
	chop;
	@l=split(/,/,$_);
	if ($i eq 0) { 
		$fn=0;
		foreach (@l) {
			if (! ($_ eq "File name")) {
				$fn++;
			} else {
				last;
			}
		}
		$dn=0;
		foreach (@l) {
			if (! ($_ eq "Dark")) {
				$dn++;
			} else {
				last;
			}
		}
	} else {
		$f=$l[$fn]; 
		$f=~/^(.+).JPG$/;
		$f=$1;
		$d=$l[$dn]; 
		print $f ."\n";
		
		print($bin."dcraw.exe -v -D -4 ".$dcrawparams." $f.".$rawtype);
		print("\n");
		system($bin."dcraw.exe -v -D -4 ".$dcrawparams." $f.".$rawtype);
		print($bin."raw2lum.exe  -t 165 -i $f.h -fa -n $f.ppm -e $f.eps $f.pgm >$f.log");
		print("\n");
		system($bin."raw2lum.exe  -t 165 -i $f.h -fa -n $f.ppm -e $f.eps $_fpgm >$f.log");
		print("------------------------\n")
	}
	$i++
}

